# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section   free
%define namedversion   1.0.1
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           cometd-javascript
Version:        1.0.1
Release:        3%{?dist}
Epoch:          0
Summary:        CometD Javascript
License:        Apache Software License 2.0
Group:          Development/Java
URL:            http://www.cometd.org/
Source0:        cometd-javascript-%{namedversion}.tgz
# svn export http://svn.cometd.com/tags/1.0.1/cometd-javascript cometd-javascript-1.0.1

Source2:        %{name}-%{version}-jpp-depmap.xml
Source3:        %{name}-%{version}-settings.xml
Patch1:         cometd-javascript-pom.patch
Patch2:         cometd-javascript-dojo-pom.patch
Patch3:         cometd-javascript-jquery-pom.patch

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2-common-poms
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit3
BuildRequires:  maven-release
BuildRequires:  jakarta-slide-webdavclient
BuildRequires:  jetty6-maven2-plugins
BuildRequires:  dojotoolkit
BuildRequires:  cometd-java-api

Requires:  java >= 0:1.6.0
Requires:  cometd-java-api

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%description
Cometd is a scalable HTTP-based event routing bus that uses
a Ajax Push technology pattern known as Comet. The term 
'Comet' was coined by Alex Russell in his post Comet: Low 
Latency Data for the Browser.
The JavaScript implementation of the Bayeux specification 
and API has been totally rewritten starting from CometD 
version 1.0.beta8, and further refactored since 1.0.beta9.
What is available now is a portable JavaScript 
implementation with bindings for the major JavaScript 
toolkits, currently Dojo and jQuery.
What this means is that the CometD Bayeux JavaScript 
implementation is written in pure JavaScript with no 
dependencies on the toolkits, and that the toolkit
bindings add the syntactic sugar that makes the Bayeux 
APIs feel like they are native to the toolkit.

%prep
%setup -q 
cp %{SOURCE3} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
%patch1 -p1 -b .sav1
%patch2 -p1 -b .sav2
%patch3 -p1 -b .sav3

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

mkdir external_repo
ln -s %{_javadir} external_repo/JPP
export M2_SETTINGS=$(pwd)/settings.xml
rm -rf dojo/src/test
rm -rf jquery/src/test/
    mvn-jpp \
        -e \
        -s $M2_SETTINGS \
        -Dmaven.test.failure.ignore=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        ant:ant install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT
# jars/poms
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.cometd.javascript cometd-javascript-project %{version} JPP cometd-javascript-project
install -m 644 pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP-cometd-javascript-project.pom

install -m 644 common/target/cometd-javascript-common-%{namedversion}.war \
               $RPM_BUILD_ROOT%{_javadir}/cometd-javascript/common-%{version}.war
%add_to_maven_depmap org.cometd.javascript cometd-javascript-common %{version} JPP/cometd-javascript common
install -m 644 common/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.cometd-javascript-common.pom

install -m 644 dojo/target/cometd-javascript-dojo-%{namedversion}.war \
               $RPM_BUILD_ROOT%{_javadir}/cometd-javascript/dojo-%{version}.war
%add_to_maven_depmap org.cometd.javascript cometd-javascript-dojo %{version} JPP/cometd-javascript dojo
install -m 644 dojo/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.cometd-javascript-dojo.pom

install -m 644 jquery/target/cometd-javascript-jquery-%{namedversion}.war \
               $RPM_BUILD_ROOT%{_javadir}/cometd-javascript/jquery-%{version}.war
%add_to_maven_depmap org.cometd.javascript cometd-javascript-jquery %{version} JPP/cometd-javascript jquery
install -m 644 jquery/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.cometd-javascript-jquery.pom

install -m 644 examples-dojo/target/cometd-examples-dojo-%{namedversion}.war \
               $RPM_BUILD_ROOT%{_javadir}/cometd-javascript/examples-dojo-%{version}.war
%add_to_maven_depmap org.cometd.javascript cometd-examples-dojo %{version} JPP/cometd-javascript examples-dojo
install -m 644 examples-dojo/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.cometd-javascript-examples-dojo.pom

install -m 644 examples-jquery/target/cometd-examples-jquery-%{namedversion}.war \
               $RPM_BUILD_ROOT%{_javadir}/cometd-javascript/examples-jquery-%{version}.war
%add_to_maven_depmap org.cometd.javascript cometd-examples-jquery %{version} JPP/cometd-javascript examples-jquery
install -m 644 examples-jquery/pom.xml $RPM_BUILD_ROOT/%{_datadir}/maven2/poms/JPP.cometd-javascript-examples-jquery.pom

(cd $RPM_BUILD_ROOT%{_javadir}/cometd-javascript && for war in *-%{version}*; do ln -sf ${war} `echo $war| sed  "s|-%{version}||g"`; done)

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun 
%update_maven_depmap

%files
%defattr(-,root,root,-)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%changelog
* Sat Aug 04 2012 Ralph Apel <r.apel at r-apel.de> 0:1.0.1-3
- Promote to free

* Sat Sep 18 2010 Ralph Apel <r.apel at r-apel.de> 0:1.0.1-2
- Require cometd-java-api if only for cometd-project.pom

* Fri Jul 30 2010 Ralph Apel <r.apel at r-apel.de> 0:1.0.1-1jpp
- 1.0.1

